(defun c:assignt (
               /
               app doc materials mat
               h mat_ent mat_def mat_id texture new_def
               )
  
  (setq app (vlax-get-acad-object)
        doc (vla-get-activedocument app)
        materials (vla-get-materials doc)
        path "C:\\Temp\\"
  )
  
  (vlax-for mat materials
    (setq mat_name (vla-get-name mat)
          h (vla-get-handle mat)
          mat_ent (handent h)
          mat_def (entget mat_ent)
          mat_id (substr mat_name 13 5)
          texture (strcat path "8-" mat_id "-texture.png")
          new_def (subst (cons 3 texture) (assoc 3 mat_def) mat_def)
    )
    (entmod new_def)
  )
  (princ)
)